package com.tacademy;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.IBinder;
import android.util.Log;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.view.animation.Animation.AnimationListener;
import android.widget.ImageView;

import com.skt.arm.aidl.IArmService;
import com.tacademy.data.DB;

public class Intro extends Activity {
	private ImageView image;
	private IArmService service;
	private ArmServiceConnection armCon;
	private String AID = "OA00028296";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		setContentView(R.layout.intro);
		
		image = (ImageView) findViewById(R.id.image);
		Animation anim = AnimationUtils.loadAnimation(this, R.anim.anim_intro);

		image.startAnimation(anim);
		anim.setAnimationListener(new AnimationListener() {

			public void onAnimationStart(Animation animation) {
				
			}

			public void onAnimationRepeat(Animation animation) {
			}

			public void onAnimationEnd(Animation animation) {
//				runArmService(); // ARM Check μ 	
				
				moveFile();
				Intent intent = new Intent(Intro.this, ToDuckList.class);
				startActivity(intent);
				finish();
			}
		});
		super.onCreate(savedInstanceState);
	}

	private boolean runArmService() {
		try {
			if (armCon == null) {
				// bindService 
				armCon = new ArmServiceConnection();
				bindService(new Intent(IArmService.class.getName()), armCon, Context.BIND_AUTO_CREATE);
			}
			return true;
		} catch (Exception e) {
			releaseService();
			return false;
		}
	}

	private void releaseService() {
		if (armCon != null) {
			// unbindService 
			unbindService(armCon);
			armCon = null;
		}
	}

	class ArmServiceConnection implements ServiceConnection {
		public void onServiceConnected(ComponentName name, IBinder boundService) {
			// bindService  onServiceConnected() ̺Ʈ ߻
			if (service == null)
				service = IArmService.Stub.asInterface((IBinder) boundService);
			try {
				// ARM Service AID 
				int res = service.executeArm(AID);
				switch (res) {
				case 1:
					//  
					// Application  
					moveFile();
					
					Intent intent = new Intent(Intro.this, ToDuckList.class);
					startActivity(intent);
					finish();
					break;
				default:
					//  
					finish();
					// ޽   Application 
					//  ڵǥ  (Appendix)
					break;
				}
			} catch (Exception e) {
				releaseService();
				return;
			}
			// ARM Service 
			releaseService();
		}

		public void onServiceDisconnected(ComponentName name) {
			service = null;
		}
	}
	
	public void moveFile(){
		SharedPreferences prefs = getSharedPreferences("mypref", 0);
		boolean isMove = prefs.getBoolean("flag", false);
		
		if(!isMove){
			DB dbCon = new DB(this);
			dbCon.moveFile();
			
			Log.d("duck", "call");
			
			SharedPreferences.Editor editor = getSharedPreferences("mypref", 0).edit();
			editor.putBoolean("flag", true);
			editor.commit();
		}
	}
}
