package com.tacademy;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.RadioButton;
import android.widget.RadioGroup;

import com.tacademy.PenPaletteDialog.OnPenSelectedListener;
import com.tacademy.data.DB;

public class Setting extends Activity implements OnClickListener{

	private View setWidth;
	private View setColor1;
	private View setColor2;
	private View setColor3;
	private RadioGroup radio;
	private int width;
	private int color;
	private int scroll;
	private int color1;
	private int color2;
	private int color3;
	
	private DB dbCon;
	private static final String ACTION_PICK_COLOR = "com.tacademy.action.PICK_COLOR";
	private static final int REQUEST_CODE_PICK_COLOR = 1;
	private static final int REQUEST_CODE_PICK_COLOR1 = 2;
	private static final int REQUEST_CODE_PICK_COLOR2 = 3;
	private static final int REQUEST_CODE_PICK_COLOR3 = 4;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.setting);
		
		setWidth = findViewById(R.id.setWidth);
		setColor1 = findViewById(R.id.color1);
		setColor1.setOnClickListener(this);
		setColor2 = findViewById(R.id.color2);
		setColor2.setOnClickListener(this);
		setColor3 = findViewById(R.id.color3);
		setColor3.setOnClickListener(this);
		findViewById(R.id.btn_save).setOnClickListener(this);
		findViewById(R.id.btn_back).setOnClickListener(this);
		findViewById(R.id.btn_width).setOnClickListener(this);
		findViewById(R.id.btn_color).setOnClickListener(this);
		radio = (RadioGroup)findViewById(R.id.radiogroup);
		
		dbCon = new DB(this);
		
		//缳 ޾ƿ.
		Integer result[] = dbCon.getDraw();
		width = result[0];
		color = result[1];
		scroll = result[2];
		
		result = dbCon.getFavoriteColor();
		color1 = result[0];
		color2 = result[1];
		color3 = result[2];
		
		setPen();
		setColor1.setBackgroundColor(color1);
		setColor2.setBackgroundColor(color2);
		setColor3.setBackgroundColor(color3);
		
		//ũ off 
		if(scroll == 0){
			RadioButton off = (RadioButton)findViewById(R.id.off);
			off.setChecked(true);
		}
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		dbCon.closeTodo();
	}
 
	@Override
	public void onClick(View v) {
		Intent intent;
		switch (v.getId()) {
		case R.id.btn_back:
			finish();
			break;
		case R.id.btn_save:
			if(radio.getCheckedRadioButtonId() == R.id.on){
				scroll = 1;
			}else{
				scroll = 0;
			}
			dbCon.setDraw(width, color, scroll);
			dbCon.setFavoriteColor(color1, color2, color3);
			finish();
			break;
		case R.id.btn_width:
			PenPaletteDialog.listener = new OnPenSelectedListener() {
				public void onPenSelected(int size) {
					width = size;
					setPen();
				}
			};
			intent = new Intent(Setting.this, PenPaletteDialog.class);
			startActivity(intent);
			break;
		case R.id.btn_color:
			intent = new Intent();
			intent.setAction(ACTION_PICK_COLOR);
			intent.putExtra("color", color);
			intent.putExtra("setting", true);
			startActivityForResult(intent, REQUEST_CODE_PICK_COLOR);
			break;
		case R.id.color1:
			intent = new Intent();
			intent.setAction(ACTION_PICK_COLOR);
			intent.putExtra("color", color1);
			intent.putExtra("setting", true);
			startActivityForResult(intent, REQUEST_CODE_PICK_COLOR1);
			break;
		case R.id.color2:
			intent = new Intent();
			intent.setAction(ACTION_PICK_COLOR);
			intent.putExtra("color", color2);
			intent.putExtra("setting", true);
			startActivityForResult(intent, REQUEST_CODE_PICK_COLOR2);
			break;
		case R.id.color3:
			intent = new Intent();
			intent.setAction(ACTION_PICK_COLOR);
			intent.putExtra("color", color3);
			intent.putExtra("setting", true);
			startActivityForResult(intent, REQUEST_CODE_PICK_COLOR3);
			break;
		}
	}
	
	 @Override
		protected void onActivityResult(int requestCode, int resultCode, Intent data) {
			super.onActivityResult(requestCode, resultCode, data);
			switch(requestCode) {
			case REQUEST_CODE_PICK_COLOR:
				if (resultCode == RESULT_OK) {
					color = data.getIntExtra("color", color);
					setPen();
				}
				break;
			case REQUEST_CODE_PICK_COLOR1:
				if (resultCode == RESULT_OK) {
					color1 = data.getIntExtra("color", color);
					setColor1.setBackgroundColor(color1);
				}
				break;
			case REQUEST_CODE_PICK_COLOR2:
				if (resultCode == RESULT_OK) {
					color2 = data.getIntExtra("color", color);
					setColor2.setBackgroundColor(color2);
				}
				break;
			case REQUEST_CODE_PICK_COLOR3:
				if (resultCode == RESULT_OK) {
					color3 = data.getIntExtra("color", color);
					setColor3.setBackgroundColor(color3);;
				}
				break;
			}
		}
	 
	 public void setPen(){
		// β 
			ViewGroup.LayoutParams params = setWidth.getLayoutParams();
			final Bitmap penBitmap = Bitmap.createBitmap(params.width, params.height, Bitmap.Config.ARGB_8888);
			final Canvas penCanvas = new Canvas();
			penCanvas.setBitmap(penBitmap);
			Paint mPaint = new Paint();
			mPaint.setColor(Color.BLACK);	
			mPaint.setAntiAlias(true);
			mPaint.setStrokeCap(Paint.Cap.ROUND);
			penCanvas.drawRect(0, 0, params.width, params.height, mPaint);
			
			mPaint.setColor(color);
			mPaint.setStrokeWidth((float)width);
			
//			penCanvas.drawCircle(params.width/2, params.height/2, width, mPaint);
			penCanvas.drawLine(10, params.height/2, params.width-10, params.height/2, mPaint);
			BitmapDrawable penDrawable = new BitmapDrawable(this.getResources(), penBitmap);
			setWidth.setBackgroundDrawable(penDrawable);
	 }
}
