package com.tacademy;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageButton;
import android.widget.ImageView;

import com.tacademy.data.DB;
import com.tacademy.view.ToDuckDraw;

public class ToDuckDrawBoard extends Activity implements OnClickListener{
	
	public static ToDuckDraw mToduckdraw;
	private static ImageView[] page;
	
	private ImageButton btn_stop;
	private static ImageButton btn_prev;
	private static ImageButton btn_next;
	public static int play_flag = 1;
	public static int now_page = 0;
	
	public static int todoIndex;
	private int noti;
	private int widget;
	private String notiDate;
	private int mColor;
	
	private static final String ACTION_PICK_COLOR = "com.tacademy.action.PICK_COLOR";
	private static final int REQUEST_CODE_PICK_COLOR = 1;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.drawboard);
        
        mToduckdraw = (ToDuckDraw)findViewById(R.id.board);
        findViewById(R.id.btn_back).setOnClickListener(this);
        btn_prev = (ImageButton)findViewById(R.id.btn_prev);
        btn_prev.setOnClickListener(this);
        btn_next = (ImageButton)findViewById(R.id.btn_next);
        btn_next.setOnClickListener(this);
        findViewById(R.id.btn_undo).setOnClickListener(this);
        findViewById(R.id.btn_clear).setOnClickListener(this);
        findViewById(R.id.btn_save).setOnClickListener(this);
        btn_stop = (ImageButton)findViewById(R.id.btn_stop);
        btn_stop.setOnClickListener(this);
        findViewById(R.id.btn_color).setOnClickListener(this);
        findViewById(R.id.btn_pen).setOnClickListener(this);
        
        //缳 ޾ƿ.
        DB dbCon;
        dbCon = new DB(this);
		Integer result[] = dbCon.getDraw();
		play_flag = result[2];
		
		if (play_flag == 0) {
			btn_stop.setBackgroundResource(R.drawable.sel_play);
		}

        now_page = 0;
        todoIndex = -1;
        
        page = new ImageView[4];
        page[0] = (ImageView)findViewById(R.id.page0);
        page[1] = (ImageView)findViewById(R.id.page1);
        page[2] = (ImageView)findViewById(R.id.page2);
        page[3] = (ImageView)findViewById(R.id.page3);
       
        if(now_page == 0){
        	btn_prev.setEnabled(false);
        }
        
        Intent intent = getIntent();
		todoIndex = intent.getIntExtra("todoIndex", -1);
		widget = intent.getIntExtra("widget", 0);
		noti = intent.getIntExtra("noti", 0);
		notiDate = intent.getStringExtra("notiDate");
        
     // FIXME: ߿ 
//	    deleteDatabase("toduck.db");
    }
	
	
	@Override
	protected void onResume() {
		
		super.onResume();
	}
	

	@Override
	protected void onStop() {
		finish();              // ɼâ    finish ǵ 
		super.onStop();
	}
	
	@Override
	public void onClick(View v) {
		Intent intent;
		switch (v.getId()) {
		case R.id.btn_undo:
			mToduckdraw.undo();
			break;
		case R.id.btn_clear:
			mToduckdraw.clear();
			break;
		case R.id.btn_save:
			intent = new Intent(ToDuckDrawBoard.this, OptionDialog.class);
			if (todoIndex != -1) { //  
				intent.putExtra("todoIndex", todoIndex);
				intent.putExtra("widget", widget);
				intent.putExtra("noti", noti);
				intent.putExtra("notiDate", notiDate);
				mToduckdraw.save(todoIndex);
			}
			startActivity(intent);
			break;
		case R.id.btn_next:
			set_page(++now_page);
			mToduckdraw.next();
			break;
		case R.id.btn_prev:
			set_page(--now_page);
			mToduckdraw.prev();
			break;
		case R.id.btn_back:
			intent = new Intent(ToDuckDrawBoard.this, ToDuckList.class);
			startActivity(intent);
			finish();
			break;
		case R.id.btn_stop:
			if (play_flag == 1) {
				btn_stop.setBackgroundResource(R.drawable.sel_play);
				play_flag = 0;
			} else {
				btn_stop.setBackgroundResource(R.drawable.sel_stop);
				play_flag = 1;
			}
			break;
		case R.id.btn_color:
			intent = new Intent();
			intent.setAction(ACTION_PICK_COLOR);
			mColor = mToduckdraw.getColor();
			intent.putExtra("color", mColor);
			startActivityForResult(intent, REQUEST_CODE_PICK_COLOR);
			break;
		case R.id.btn_pen:
			mToduckdraw.setPen();
			intent = new Intent(ToDuckDrawBoard.this, PenPaletteDialog.class);
			startActivity(intent);
			break;
		}
	}
	
	/////////////////////////////////////////////////////
	// Color changed listener:
	
    @Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);
		switch(requestCode) {
		case REQUEST_CODE_PICK_COLOR:
			if (resultCode == RESULT_OK) {
				mColor = data.getIntExtra("color", mColor);
				mToduckdraw.setColor(mColor);
			}
			break;
		}
	}
    
    public static void set_page(int nowpage){
    	for(int i=0; i<4; i++){
    		if(nowpage == i){
    			page[i].setImageResource(R.drawable.icon_nowpage);
    		}
    		else{
    			page[i].setImageResource(R.drawable.icon_page);
    		}
    	}
    	btn_prev.setEnabled(true);
    	btn_next.setEnabled(true);
    	if(now_page == 3){
			btn_next.setEnabled(false);
		}		
		else if(now_page == 0){
			btn_prev.setEnabled(false);
		}
    }
}