package com.tacademy.background;

import android.app.AlarmManager;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.IBinder;

import com.tacademy.R;
import com.tacademy.ToDuckList;
import com.tacademy.data.DB;

public class ToDuckNotification extends Service {
	
	private static final int TODUCK_NOTIFICATION = 1;
	private static DB dbCon;
	
	public static void schedule(Context context) {
		AlarmManager am = (AlarmManager) context
				.getSystemService(Context.ALARM_SERVICE);
		Intent intent = new Intent(context, ToDuckNotification.class);
		PendingIntent pi = PendingIntent.getService(context, 0, intent, 0);
		
		//FIXME:  ۽ð 
		//  ݺϴ° ͸ Ҹ 
		am.setInexactRepeating(AlarmManager.RTC_WAKEUP,
						System.currentTimeMillis()+2000, 216000000, pi); //1ð ѹ 
		// am.setRepeating(type, triggerAtTime, interval, operation);

	}
	
	@Override
	public IBinder onBind(Intent arg0) {
		return null;
	}

	@Override
	public void onStart(Intent intent, int startId) {
		super.onStart(intent, startId);
		dbCon = new DB(this.getApplicationContext());
		
		int notiCount = dbCon.select_noti();
		dbCon.delete_noti();
		dbCon.closeTodo();
		
		if(notiCount != 0){
			notifyNewToduck(notiCount);
		}
		stopSelf();
	}
	
	@Override
	public void onDestroy() {
		super.onDestroy();
	}

	void notifyNewToduck(int notiCount) {
		NotificationManager nm = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
		Notification noti = new Notification(R.drawable.icon,
				"New TODO!", System.currentTimeMillis());
		
		
		Intent intent = new Intent(this, ToDuckList.class);
		intent.putExtra("noti", true);
		PendingIntent pi = PendingIntent.getActivity(this, 0, intent, 0);
		noti.setLatestEventInfo(this, "TODUCK", notiCount + "    ֽϴ.", pi);
		nm.notify(TODUCK_NOTIFICATION, noti);
		
	}

}
